/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006 by Witz Corporation, JAPAN
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *
 */

/*
 *  vZbTˑW[iAT91SAM7Spj
 */


#ifndef	_CPU_CONFIG_H_
#define	_CPU_CONFIG_H_

#define MAX_IPM  0xf	/* X^uȂ̏ꍇ͍ōDxCPUbN */


#ifndef _MACRO_ONLY
#include "cpu_insn.h"
#endif /* _MACRO_ONLY */


#ifndef _MACRO_ONLY
/* CC֐vg^Cv錾	*/
Inline void set_ipl(UINT8 ipl);
Inline UINT8 current_ipl(void);


/*
 *  {OSJ[lł͊ݐItOyIPL̑opčs
 *  ƂOƂD{CPUIPL݂̂Ȃ߁A
 *  ItO\tgEFAŕ₤dlƂ
 */

/*
 *  ݗDxxݒ
 */
Inline void set_ipl(UINT8 ipl)
{
}


/*
 *  ݗDxx擾
 */
Inline UINT8 current_ipl(void)
{
	return 0;
}


/*
 *  vZbTˑ̏(cpu_config.c)
 */
extern void	cpu_initialize(void);

/*
 *  vZbTˑ̏I(cpu_config.c)
 */
extern void	cpu_terminate(void);

//Added additional data structures for saving 'spsr' and 'lr' values of the preempted task.
//These values reflect the state of the task when it was interrupted by timer isr.
//These are updated before jumping to the preempting task. Whenever control returns back to the preempred task
// @ context_restore, only the registers need ot be restored, and spsr as well as lr values can be retrieved from these data structures.
// If as an alternative to this, one wants to store even 'spsr' and 'lr' values on the stack, then stack management becomes difficult
//Hence separate daat structures are used for simplicity

//Also a separate flag is maintyained for each task to indicate if it was preempted. This is used in tcxb_preempt_flg

#define DEFINE_CTXB(tnum) \
FP tcxb_pc[tnum]; \
VP tcxb_sp[tnum];\
VP tcxb_spsr[tnum];\
VP tcxb_preempt_flg[tnum];\
VP tcxb_lr[tnum];


extern FP tcxb_pc[];
extern VP tcxb_sp[];

/* fBXpb`̃AZu֐vg^Cv錾	*/
extern void  dispatch(void);
extern void  exit_and_dispatch(void);
extern void  start_dispatch(void);

#endif /* _MACRO_ONLY */
#endif	/* _CPU_CONFIG_H_	*/

